/*
 * kgraft_patch_bsc1193161
 *
 * Fix for CVE-2019-0136, bsc#1193161
 *
 *  Upstream commits:
 *  588f7d39b359 ("mac80211: drop robust management frames from unknown TA")
 *  79c92ca42b5a ("mac80211: handle deauthentication/disassociation from TDLS
 *                 peer")
 *
 *  SLE12-SP3 commits:
 *  9a9bbf08479646eed538510019782c092c8333e9
 *  51c50fbb3f3e9dd15d86da005f3d6d55c6f80c66
 *
 *  SLE12-SP4, SLE12-SP5, SLE15 and SLE15-SP1 commits:
 *  b226a9581fe005f8693ece9e69ec12b254cfa31f
 *  32cabcf52638a3cbcdd1456dba8c3c4bec37a6cc
 *
 *  SLE15-SP2 and SLE15-SP3 commit:
 *  not affected
 *
 *
 *  Copyright (c) 2021 SUSE
 *  Author: Marcos Paulo de Souza <mpdesouza@suse.com>
 *
 *  Based on the original Linux kernel code. Other copyrights apply.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#if IS_ENABLED(CONFIG_MAC80211)

#if !IS_MODULE(CONFIG_MAC80211)
#error "Live patch supports only CONFIG_MAC80211=m"
#endif

#include "kgr_patch_bsc1193161.h"

int kgr_patch_bsc1193161_init(void)
{
	int ret;

	ret = kgr_patch_bsc1193161_net_mac80211_rx_init();
	if (ret)
		return ret;

	ret = kgr_patch_bsc1193161_net_mac80211_mlme_init();
	if (ret)
		kgr_patch_bsc1193161_net_mac80211_rx_cleanup();

	return ret;
}

void kgr_patch_bsc1193161_cleanup(void)
{
	kgr_patch_bsc1193161_net_mac80211_mlme_cleanup();
	kgr_patch_bsc1193161_net_mac80211_rx_cleanup();
}

#endif /* IS_ENABLED(CONFIG_MAC80211) */
